#include <iostream>
#include <fstream>

using namespace std;

int main(int argc,char** argv){
  //Syntaxe correcte
  //Attention l'argument 0 est le nom du programme
  if(argc!=4){
    cout<<"Usage : \033[32mdecode fichier_chiffre fichier_clair cle\033[30m"<<endl;
    cout<<"        ou \033[31mfichier_chiffre\033[30m est un fichier texte et \033[31mcle\033[30m est une lettre minuscule."<<endl;
    return -1;
  }

  //Rcupration des arguments
  string nomFichierChiffre(argv[1]);
  string nomFichierClair(argv[2]);
  string stringCle(argv[3]);
  
  //Vrification de la cl
  if(stringCle.size()!=1){
    cout<<"\033[31mErreur\033[30m : La cle doit etre de longueur 1."<<endl;
    return -2;
  }
  char cle=stringCle[0];
  if(cle<'a' || cle>'z'){
    cout<<"\033[31mErreur\033[30m : La cle doit etre une lettre minuscule."<<endl;
    return -3;
  }
  int decalage=cle-'a';

  //Ouverture du fichier chiffre pour lecture
  fstream fichierChiffre;
  fichierChiffre.open(nomFichierChiffre.c_str(),ios::in);
  if(!fichierChiffre.is_open()){
    cout<<"\033[31mErreur\033[30m : Impossible d'ouvrir le fichier \033[32m"<<nomFichierChiffre<<"\033[30m en lecture."<<endl;
    return -4;
  }

  //Ouverture du fichier clair pour criture
  fstream fichierClair;
  fichierClair.open(nomFichierClair.c_str(),ios::out);
  if(!fichierClair.is_open()){
    cout<<"\033[31mErreur\033[30m : Impossible d'ouvrir le fichier \033[32m"<<nomFichierChiffre<<"\033[30m en ecriture."<<endl;
    return -5;
  }

 char caractereClair,caractereChiffre;
  //Parcours des caractres du fichier chiffre
  while(fichierChiffre.read(&caractereChiffre,1)>0){
    //La caractre caractereClair est-il une lettre minuscule ?
    if(caractereChiffre>='a' && caractereChiffre<='z'){
      //Si oui on le dcale de dcalage
      caractereClair=caractereChiffre-decalage;
      if(caractereClair<'a'){
	caractereClair+=26;
      }
    }
    //Sinon, est-il une lettre majuscule ?
    else if(caractereChiffre>='A' && caractereChiffre<='Z'){
      //Si oui on le dcale de dcalage
      caractereClair=caractereChiffre-decalage;
      if(caractereClair<'A'){
	caractereClair-=26;
      }
    }
    //Sinon, on ne chiffre pas
    else{
      caractereClair=caractereChiffre;
    }
    //On ecrit le caractere clair dans fichierClair
    fichierClair<<caractereClair;
  }
  //On ferme les fichiers
  fichierClair.close();
  fichierChiffre.close();
}
